
!ABCIncludeFile

 OMIT('_EndOfInclude_',_RevBrwPresent_)
_RevBrwPresent_ EQUATE(1)

  include('AbBrowse.INC'),once
  include('keycodes.clw'),once

! last update 17 Mar 01
! Compiler 5.5b
!      removed references to BrowseClass property ListControl
!      used ILC GetControl method
!      Changed key code properties to protected and added method to Set
!      Removed virtual attribute from some methods
!
!      update 6 Jul 01
!      Removed control queue and replaced with long variables
!      added bit masks to control reverse of order
!      Removed screen control options
!
! -------------------------------------------------------------------------------------------
BrowseReverseClass class(BrowseClass),MODULE('RevBrw.CLW'),TYPE,LINK('RevBrw.clw',_ABCLinkMode_),DLL(_ABCDllMode_)
ReverseOrder         long,private   ! allow this order to be reversed
ReverseOnClick       long,private   ! allow this order to reverse on header click
ReverseStatus        long,private   ! bit on order reversed, bit off normal
! queue one element each sort order
RevKeyCode           long,protected        ! keycode to toggle sort
! ------------------
! public methods
! ------------------
SetReverse        procedure(long SortNumber = 0, byte Rev = false)
! set the order to allow reverse,  if Rev true order begins reversed
SetHeaderReverse  procedure(long SortNumber = 0)
! set the flag to allow reverse sorting on list box header double click
! ---------------
! private methods
! ---------------
ToggleSort        procedure,private
! toggle the current reverse status
! ---------------
! protected methods
! ---------------
SetRevAlertKey    procedure(long k = AltV),protected
! set the alert key code to reverse the current browse sort
! ----------------
! virtual methods
! ---------------
Next              PROCEDURE,BYTE,VIRTUAL
! read next record, reads previous if Rev
Previous          PROCEDURE,BYTE,VIRTUAL
! read previous record, reads next if reverse
SetSort           procedure(BYTE NewOrder,BYTE Force),BYTE,VIRTUAL,PROC
! set the sort order, get the reverse status call parent
TakeKey           procedure,BYTE,PROC,VIRTUAL
! process keystrokes for reverse
                    end ! class
! ---------------------------------------------------------------------------------------------

_EndOfInclude_